/***************************************************************************
 *   Copyright (C) 2008 by SK Communications.                              *
 *   http://kldp.net/projects/nateon/                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ADDFORM_H
#define ADDFORM_H

#include <qvariant.h>
#include <qpixmap.h>
#include <qdialog.h>
//Added by qt3to4:
#include <Q3VBoxLayout>
#include <Q3GridLayout>
#include <Q3HBoxLayout>
#include <QLabel>
#include <kstandarddirs.h>
#include <kaboutdata.h>
#include <kcomponentdata.h>

#include "shapewidget.h"

class Q3VBoxLayout;
class Q3HBoxLayout;
class Q3GridLayout;
class QSpacerItem;
class QLabel;
class QLineEdit;
class QPushButton;
class QComboBox;
class Q3ListView;
class Q3ListViewItem;
class ShapeButton;
class ShapeWidget;
class ShapeForm;

class AddForm : public QDialog {
    Q_OBJECT

public:
    AddForm( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, Qt::WFlags fl = 0 );
    ~AddForm();

    QLabel* textLabel1;
    QLineEdit* lineEdit1;
    ShapeButton* pushButton1; /*! 검색 */
    QLabel* textLabel2;
    QComboBox* comboBox1;
    Q3ListView* listView1;
    ShapeButton* pushButton2; /*! 추가 */
    ShapeButton* pushButton3; /*! 삭제 */
    QLabel* textLabel3;
    Q3ListView* listView2;
    ShapeButton* pushButton4; /*! 확인 */
    ShapeButton* pushButton5; /*! 취소 */

protected:
    Q3VBoxLayout* AddFormLayout;
    Q3VBoxLayout* layout9;
    Q3HBoxLayout* layout1;
    QSpacerItem* spacer1;
    Q3HBoxLayout* layout7;
    Q3VBoxLayout* layout3;
    Q3HBoxLayout* layout2;
    Q3VBoxLayout* layout5;
    QSpacerItem* spacer2;
    QSpacerItem* spacer3;
    Q3VBoxLayout* layout6;
    Q3HBoxLayout* layout8;
    QSpacerItem* spacer4;
    QSpacerItem* spacer5;

protected slots:
    virtual void languageChange();

private:
    QPixmap image0;

};

#endif // ADDFORM_H
